#include <windows.h>
#include "wndsize.h"

void WDL_WndSizer::init(HWND hwndDlg)
{
  m_hwnd=hwndDlg;
  GetClientRect(m_hwnd,&m_orig_rect);
  m_list.Resize(0);
}

void WDL_WndSizer::init_item(int dlg_id, float left_scale, float top_scale, float right_scale, float bottom_scale)
{
  RECT this_r;
  HWND h=GetDlgItem(m_hwnd,dlg_id);
  GetWindowRect(h,&this_r);
  ScreenToClient(m_hwnd,(LPPOINT) &this_r);
  ScreenToClient(m_hwnd,((LPPOINT) &this_r)+1);

  int osize=m_list.GetSize();
  m_list.Resize(osize+sizeof(WDL_WndSizer__rec));

  WDL_WndSizer__rec *rec=(WDL_WndSizer__rec *) ((char *)m_list.Get()+osize);

  rec->hwnd=h;
  rec->scales[0]=left_scale;
  rec->scales[1]=top_scale;
  rec->scales[2]=right_scale;
  rec->scales[3]=bottom_scale;

  rec->orig = this_r;
}

void WDL_WndSizer::onResize()
{
  WDL_WndSizer__rec *rec=(WDL_WndSizer__rec *) ((char *)m_list.Get());
  int cnt=m_list.GetSize() / sizeof(WDL_WndSizer__rec);

  HDWP hdwndpos=NULL;
  if (GetVersion() < 0x80000000) hdwndpos=BeginDeferWindowPos(cnt);
  RECT new_rect;
  GetClientRect(m_hwnd,&new_rect);

  int x;
  for (x = 0; x < cnt; x ++)
  {
    RECT r;
    if (rec->scales[0] <= 0.0) r.left = rec->orig.left;
    else if (rec->scales[0] >= 1.0) r.left = rec->orig.left + new_rect.right - m_orig_rect.right;
    else r.left = rec->orig.left + (int) ((new_rect.right - m_orig_rect.right)*rec->scales[0]);

    if (rec->scales[1] <= 0.0) r.top = rec->orig.top;
    else if (rec->scales[1] >= 1.0) r.top = rec->orig.top + new_rect.bottom - m_orig_rect.bottom;
    else r.top = rec->orig.top + (int) ((new_rect.bottom - m_orig_rect.bottom)*rec->scales[1]);

    if (rec->scales[2] <= 0.0) r.right = rec->orig.right;
    else if (rec->scales[2] >= 1.0) r.right = rec->orig.right + new_rect.right - m_orig_rect.right;
    else r.right = rec->orig.right + (int) ((new_rect.right - m_orig_rect.right)*rec->scales[2]);

    if (rec->scales[3] <= 0.0) r.bottom = rec->orig.bottom;
    else if (rec->scales[3] >= 1.0) r.bottom = rec->orig.bottom + new_rect.bottom - m_orig_rect.bottom;
    else r.bottom = rec->orig.bottom + (int) ((new_rect.bottom - m_orig_rect.bottom)*rec->scales[3]);
    
    if (!hdwndpos) SetWindowPos(rec->hwnd, NULL, r.left,r.top,r.right-r.left,r.bottom-r.top, SWP_NOZORDER|SWP_NOACTIVATE);
    else DeferWindowPos(hdwndpos, rec->hwnd, NULL, r.left,r.top,r.right-r.left,r.bottom-r.top, SWP_NOZORDER|SWP_NOACTIVATE);
    rec++;
  }
  if (hdwndpos) EndDeferWindowPos(hdwndpos);

}